<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>

<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="java.net.URLDecoder" %>

<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>
<%@ page import="org.apache.commons.lang.StringEscapeUtils" %>

<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.PredicateBean" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBean" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.actions.WebUIUtility" %>

<%@ page import="com.alarmpoint.servicemanager.cm.ServiceManagerScriptObject" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<jsp:useBean id="serviceManagerCmBean"
             class="com.alarmpoint.servicemanager.cm.ServiceManagerScriptObject"
             scope="page" />

<%@ include file="SMCMConfig.jsp" %>

<page>



<window-popup onload="updateCurrentAffectedCINames();">

<%
    URLDecoder urlDecoder = new URLDecoder();

    // =================================================================================================================
    // build filter to handle post from this page and determine if post back operation
    // =================================================================================================================
    String filterValueRaw =  request.getParameter("FilterValue");
    String filterValue = filterValueRaw != null ? urlDecoder.decode( filterValueRaw, "UTF-8" ) : null;

    String[] itemsAllRaw = request.getParameterValues("items");
    String[] items = null;
    if( itemsAllRaw != null )
    {
        items = new String[itemsAllRaw.length];
        for ( int ii = 0; ii < itemsAllRaw.length; ii++ )
        {
            items[ii] = urlDecoder.decode( itemsAllRaw[ii], "UTF-8" );
        }
    }

    String webServiceFilterValue = filterValue; 
    String filterOperator = request.getParameter("FilterOperator");
    final boolean processingPostBack = ( filterOperator != null );
    String webServiceQueryOp = "=";  // MATCHES
    if( filterValue != null )
    {

        if( filterOperator.equals( "STARTS_WITH" ) )
        {
            webServiceQueryOp = "like";
            webServiceFilterValue = webServiceFilterValue + "*";
        }
        else if( filterOperator.equals( "ENDS_WITH" ) )
        {
            webServiceQueryOp = "like";
            webServiceFilterValue = "*" + webServiceFilterValue;
        }
        else if( filterOperator.equals( "CONTAINS" ) )
        {
            webServiceQueryOp = "like";
            webServiceFilterValue = "*" + webServiceFilterValue +"*";
        }
    }
    else
    {
        filterValue = "";
        webServiceFilterValue = "";
    }

    // =================================================================================================================
    // query SM for the list 
    // =================================================================================================================
    Collection<String> configurationItemList = null;
    String query = "";
    if ( processingPostBack )
    {
        query = " ConfigurationItem " + webServiceQueryOp + " \"" + webServiceFilterValue + "\"";
        
        serviceManagerCmBean.initializeClient( SERVICE_MANAGER_URL, SERVICE_MANAGER_USER, SERVICE_MANAGER_PASSWORD );

        configurationItemList = serviceManagerCmBean.getSortedList( "RetrieveDeviceListRequest", query, "ConfigurationItem" );
    }

%>

<%@ include file="SMCMJSInclude.jsp" %>
<script type="text/javascript">

  // Adds the list of selected items selected in the parent
  // window to this list.
  function updateCurrentAffectedCINames()
  {
<%
    if ( !processingPostBack ) // do not want to load from the parent if this is a post back
    {
        // need to fetch the correct 'case' of the predicate name
        PredicateBean predicateBean = subscriptionBean.getPredicateByName( AFFECTED_CI_PREDICATE_NAME );
        String predicateId = predicateBean.getPredicateValueWidgetId();
%>
    var selectedItemsList = document.getElementById("items");

    var parentForm = self.opener.document.forms[0];
    var source = parentForm['<%= predicateId %>'];

    removeAllOptions( selectedItemsList );
    if(source.options.length != 0)
    {
      // copy from source to left list
      copyAllOptions(source, selectedItemsList);
    }
<%
    }
%>
  }


  function updateParentForm( childForm )
  {
    selectAllTargetOptions( childForm, 'items' );
    var source = childForm['items'];
    self.opener.updateCurrentAffectedCIs( source );
    self.close();
    return false;
  }

  
</script>

<form-template name="POPUP_FORM"
               onsubmit="selectAllTargetOptions(this, 'policyNames');"
               form-action=".<%=request.getServletPath()%>/jsp/subscription/hpsmcm-3-0/SMCMAffectedCI.jsp;jsessionid=<%= session.getId()%>">

<group label="Search Configuration Items">

  <div class="no-list-table-data-title">
    <caption>
      <span style="white-space:normal;">To find a list of available Configuration Items, specify your search criteria, and then click "Get Configuration Items".</span>

    </caption>
  </div>

  <div class="form-group">
    <table>
      <tr>
        <th>Name</th><th>Operator</th><th>Value</th>
      </tr>
      <tr>
        <td>Configuration Item</td>
        <td type="template">
          <select id="FilterOperator" name="FilterOperator">
            <option
<%
 if(filterOperator == null || filterOperator.equals("CONTAINS") || filterOperator.equals(""))
 {
%>
 selected="true"
<%
 }
%>
              value="CONTAINS">CONTAINS</option>
            <option
<%
 if(filterOperator != null && filterOperator.equals("ENDS_WITH"))
 {
%>
 selected="true"
<%
 }
%>
              value="ENDS_WITH">ENDS WITH</option>
            <option
<%
 if(filterOperator != null && filterOperator.equals("STARTS_WITH"))
 {
%>
 selected="true"
<%
 }
%>
              value="STARTS_WITH">STARTS WITH</option>
            <option
<%
 if(filterOperator != null && filterOperator.equals("MATCHES"))
 {
%>
 selected="true"
<%
 }
%>
              value="MATCHES">MATCHES</option>
          </select>
        </td>
        <td type="template">
          <input id="FilterValue" name="FilterValue" value="<%= filterValue %>"/>
        </td>
      </tr>
    </table>
  </div>


  <action-button id="refreshButton" label="Get Configuration Items" onclick="doPrePostActions();return true;" />

</group>

<div class="form-group">

  <div class="double-list-widget">
    <label>Available Configuration Items:</label>
    <br clear="all"/>
    <select style="width:500px;" multiple="0" name="items.unselected" id="items.unselected" size="10" ondblclick="add();">
<%
  if ( configurationItemList != null )
  {
    for( String configurationItemName : configurationItemList )
    {
      String configurationItemNameEscaped = StringEscapeUtils.escapeHtml( configurationItemName );
      out.print( "<option value=\"" + configurationItemNameEscaped + "\">" + configurationItemNameEscaped + "</option>\n" );
    }
  }
%>
    </select>
  </div>

  <div class="double-list-button-cluster">
    <div class="float-none">
      <span id="addButton">
        <input id="addButton:input" class="double-list-action" name="addButton" type="button"
               onclick="add(); return false;" value="Add &gt;"/>
      </span>
      <br/>
      <span id="removeButton">
        <input id="removeButton:input" class="double-list-action" name="removeButton" type="button"
               onclick="remove(); return false;" value="&lt; Remove"/>
      </span>
    </div>
  </div>

  <div class="double-list-widget">
    <label>Selected Configuration Items:</label>
    <br clear="all"/>
    <select  style="width:500px;" multiple="0" name="items" id="items" size="10" ondblclick="remove();">
<%
    if ( items != null )
    {
        for ( String item : items )
        {
           String escapedItem = StringEscapeUtils.escapeHtml( item );
           out.print( "<option value=\"" + escapedItem + "\">" + escapedItem + "</option>" );
        }
    }
%>
    </select>
  </div>
  
</div>


<action-button id="submitButton" label="Save" onclick="return updateParentForm(this.form);" />

</form-template>
</window-popup>
</page>
