<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="org.apache.commons.lang.StringEscapeUtils" %>

<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>
<%@ page import="com.alarmpoint.servicemanager.cm.ServiceManagerScriptObject" %>
<%@ page import="org.springframework.web.context.WebApplicationContext"%>
<%@ page import="com.invoqsystems.apex.web.cocoon.actions.WebUIUtility"%>
<%@ page import="org.springframework.web.context.support.WebApplicationContextUtils"%>
<%@ page import="com.invoqsystems.apex.services.view.SubscriptionService" %>
<%@ page import="com.invoqsystems.apex.model.SubscriptionDomain" %>


<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<jsp:useBean id="serviceManagerCmBean"
             class="com.alarmpoint.servicemanager.cm.ServiceManagerScriptObject"
             scope="page" />

<%@ include file="SMCMConfig.jsp" %>

<%

  final String SUBCATEGORY_POPUP_URL = request.getServletPath() + "/jsp/subscription/hpsmcm-3-0/SMCMSubCategory.jsp;jsessionid="+session.getId();
  final String AFFECTED_CI_POPUP_URL = request.getServletPath() + "/jsp/subscription/hpsmcm-3-0/SMCMAffectedCI.jsp;jsessionid="+session.getId();


  final String subId = (String)request.getParameter("subscriptionId");
  final boolean creatingSubscription = (subId == null || "0".equals(subId));

  serviceManagerCmBean.initializeClient(SERVICE_MANAGER_URL, SERVICE_MANAGER_USER, SERVICE_MANAGER_PASSWORD);

  if (!creatingSubscription) {
    Long subDomainID = Long.valueOf((String)request.getParameter("subscriptionDomainId"));
    SubscriptionDomain domain = service.getSubscriptionDomain(subDomainID);

    /*
    * Get defaults for Subscription Domain
    */
    ignoreDeviceDelaysDefault = domain.getIgnoreDeviceDelaysDefault();
    overrideDeviceSeverityDefault = domain.getOverrideDeviceSeverityDefault();
    overrideTimeframeDefault = domain.getOverrideTimeframeDefault();
  }
%>

<subscription-panel xmlns:fi="http://apache.org/cocoon/forms/1.0#instance"
                    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
                    onload="onLoad();"
                    onsubmit="return validateForm(this);" >

<%@ include file="SMCMJSInclude.jsp" %>

<%

  // set up the map for storing the selected values for each predicate
  final HashMap<String, ArrayList<String>> selectedPredicateValuesMap = new HashMap<String, ArrayList<String>>();
  final HashMap<String, PredicateBean> predicateBeanMap = new HashMap<String, PredicateBean>();
  final HashMap<String, String> predicateSummaryNamesMap = new HashMap<String, String>();

  final StringBuffer summaryName = new StringBuffer();
  // collect the selected predicate values, and pre-populated values
  Iterator<PredicateBeanImpl> iterator = subscriptionBean.getPredicateIterator();
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     ArrayList<String> selectedValues = new ArrayList<String>();
     selectedValues.addAll(predicate.getSelectedValues());

     selectedPredicateValuesMap.put(predicate.getPredicateName().toLowerCase(), selectedValues);
     predicateBeanMap.put(predicate.getPredicateName().toLowerCase(), predicate);

     if(!predicate.getSelectedValues().isEmpty())
     {
       summaryName.delete(0, summaryName.length());
     if(predicate.hasAnySelectedValue())
       {
         summaryName.append("ANY");
       }
     else
     {
         Iterator<String> valIter = predicate.getSelectedValues().iterator();
         while(valIter.hasNext())
         {
           summaryName.append(valIter.next());
           if(valIter.hasNext())
             summaryName.append(", ");
           if(summaryName.length() > MAX_DISPLAY_CHARACTERS)
           {
             summaryName.setLength(MAX_DISPLAY_CHARACTERS);
             break;
           }
         }
     }
       predicateSummaryNamesMap.put(predicate.getPredicateName().toLowerCase(), summaryName.toString());
    }
  }


  /**
   * This tab count will contain the total number tabs that will be displayed.
   */
  // THe total number of tabs that will be displayed
  int tabCount = 3;
  if(creatingSubscription)
  {
    tabCount--;
  }
  if(subscriptionBean.isSelfSubscription())
  {
    tabCount--;
  }
  if(subscriptionBean.allOverridesSuppressed() && subscriptionBean.isTimeframeSuppressed())
  {
    tabCount--;
  }

  /**
   * This maps the tab position for each predicate.
   */
  final HashMap<String, String> predicateTabPositionMap = new HashMap<String, String>();
  predicateTabPositionMap.put(CATEGORY_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SUBCATEGORY_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(PRIORITY_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SEVERITY_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(IMPACT_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SERVICE_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(PHASE_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(TRIGGER_RULE_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(AFFECTED_CI_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(ASSIGNED_TO_DEPT_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(CHANGE_COORDINATOR_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(INITIATOR_PREDICATE_NAME, "1");

  final LinkedHashMap<String, String> predicateLabelMap = new LinkedHashMap<String, String>();
  predicateLabelMap.put(CATEGORY_PREDICATE_NAME, "Category");
  predicateLabelMap.put(SUBCATEGORY_PREDICATE_NAME, "Subcategory");
  predicateLabelMap.put(PRIORITY_PREDICATE_NAME, "Priority");
  predicateLabelMap.put(SEVERITY_PREDICATE_NAME, "Urgency");
  predicateLabelMap.put(IMPACT_PREDICATE_NAME, "Impact");
  predicateLabelMap.put(SERVICE_PREDICATE_NAME, "Service");
  predicateLabelMap.put(PHASE_PREDICATE_NAME, "Phase");
  predicateLabelMap.put(TRIGGER_RULE_PREDICATE_NAME, "Trigger Rule");
  predicateLabelMap.put(AFFECTED_CI_PREDICATE_NAME, "Affected CI");
  predicateLabelMap.put(ASSIGNED_TO_DEPT_PREDICATE_NAME, "Assignment Group");
  predicateLabelMap.put(CHANGE_COORDINATOR_PREDICATE_NAME, "Change Coordinator");
  predicateLabelMap.put(INITIATOR_PREDICATE_NAME, "Initiator");

  final Set<String> predicateList = predicateLabelMap.keySet(); 

 %>

<style media="screen" type="text/css">
  span.forms-tab {    
    display: inline;
    position: relative;
    top: -1px;
    z-index: 1;
    overflow: hidden;
    font-weight: bold;    
    text-decoration: none;
    cursor: pointer;
    color: #555555;    
    background: transparent url(/static/images/layout/main-menu-bg-off.gif) no-repeat top left;
    padding: 6px 7px 1px 11px;
    border-right: 1px solid #666;
    border-bottom: 1px solid #666;
    border-top: none;
    border-left: none;    
    margin: 0;
  }

  span.forms-tab:hover {    
    background: transparent url(/static/images/layout/main-menu-bg-hover.gif) no-repeat top left;
  }

  span.forms-tab.forms-activeTab {
    display: inline;
    position: relative;
    top: 1px;
    z-index: 10;    
    overflow: hidden; 
    cursor: default;
    color: #000000;
    background: transparent url(/static/images/layout/main-menu-bg-selected.gif) no-repeat top left;
    padding: 7px 7px 1px 11px;
    border-bottom: none;
  }

  span.forms-tab.forms-activeTab:hover {
    background-color: #FFF;
    position: relative;
  }

  span.forms-tabContent {
    background-color: #FFF;
    border: 1px solid #666;
    /*padding: 3em;*/
    position: relative;
    z-index: 2;
  }

  #sandbag-01,
  #sandbag-02 {
    clear: left;
    float: left;
    padding: 0pt; /*border: 1px solid #0f0;*/
  }

  #sandbag-01 {
    height: 10px;
    width: 160px;
  }

  #sandbag-02 {
    height: 10px;
    width: 95px;
  }

  #refreshNodeButton, #refreshNodeGroupsButton {
    line-height: 18px;
    vertical-align: top;
  }

  #PREDICATE_VALUE_NODE, #PREDICATE_VALUE_NODE_GROUPS {
    width: 115px;
  }

  label#matching {
    font-weight: bold;
    width: 175px;
  }

  div.form-row label.summary {
    font-weight: bold;
    width: 85px;
    float: none;
    text-align: left;
    vertical-align: middle;
    padding: 0px 4px 0px 0px;
    margin-left: 0px;
  }

  span.summary-row {
    float: none;
    text-align: left;
    vertical-align: middle;
    padding: 0px 0px 0px 0px;
  }

  span.summary-row span.summary-item {
    float: none;
    padding: 0px 5px 0px 0px;
  }

  span.elipse {
    font-size: 11px;
    color: #0000CC;
    margin: 0px 0px 0px 5px;
    padding: 0;
    text-decoration: underline;
    background-color: transparent;
    border: none;
    cursor: pointer;
  }

  div.form-row ul#summary_list {
    margin-left: 100px;
    padding: 0px 0px 0px 0px;
  }

  div.form-row ul#summary_list li {
    display: list-item;
    padding: 0px 3px 0px 0px;
  }

  div.form-row ul#summary_list li.summary_AND {
    font-weight: bold;
    list-style: none;
    margin-left: 20px;
  }

  div.form-row ul#summary_list li.summary-item span.summary_text italic {
    font-style: italic;
  }

  .floatLeft {
    float: left;
  }
</style>

<script type="text/javascript" language="JavaScript">
  var old_forms_showTab;
  function onLoad()
  {
   old_forms_showTab = forms_showTab;
   forms_showTab = new_forms_showTab;
   var lastTab = document.DefaultSubscriptionForm.currentTab.value;
    if(window.location.hash == "#recipients")
      lastTab = 4;
   if(lastTab != null &amp;&amp; lastTab != "" &amp;&amp; lastTab != "null")
     forms_showTab("attributes", lastTab, 5, "");
  }
  
  function new_forms_showTab(tabgroup, idx, length, state)
  {
    document.DefaultSubscriptionForm.currentTab.value = idx;
    old_forms_showTab(tabgroup, idx, length, state);
  }
  
  // Adds the list of selected items selected in the child
  // window to the list on this page. It is called by child window.
  function updateCurrentSubcategories(source)
  {
<%
    String subCategoryListId = "";
    PredicateBean predicateBeanSubCategory = predicateBeanMap.get( SUBCATEGORY_PREDICATE_NAME );
    if ( predicateBeanSubCategory != null )
    {
        subCategoryListId = predicateBeanSubCategory.getPredicateValueWidgetId();
    }
%>
    var target = document.getElementById('<%= subCategoryListId %>');
    setSelectionOptions( source, target );
    setAllSelected( target );
  }

  // Adds the list of selected items selected in the child
  // window to the list on this page. It is called by child window.
  function updateCurrentAffectedCIs(source)
  {
<%
    String affectedCiListId = "";
    PredicateBean predicateBeanAffectedCi = predicateBeanMap.get( AFFECTED_CI_PREDICATE_NAME );
    if ( predicateBeanAffectedCi != null )
    {
        affectedCiListId = predicateBeanAffectedCi.getPredicateValueWidgetId();
    }
%>

    var target = document.getElementById('<%= affectedCiListId %>');
    setSelectionOptions( source, target );
    setAllSelected( target );
  }

  function setSelectionOptions(source, target)
  {
    removeAllOptions( target );

    copySelectedOptions( source, target );
  }

  function removeAllOptions(from)
  {
    for (var i=(from.options.length-1); i>=0; i--)
    {
      from.options[i] = null;
    }
    from.selectedIndex = -1;
  }

  function popup( href, name )
  {
    if ( !window.focus ) return true;
    windowPopup( href , name, '800','600','center','front' );
    return false;
  }

  function getSelectedOptions( selectBox )
  {
    var selectedArray = new Array();
    var i;
    var count = 0;

    for ( i = 0; i &lt; selectBox.options.length; i++ )
    {
      if ( selectBox.options[i].selected )
      {
        //if ( window.console ) console.log( "adding: %s", selectBox.options[i].value );
        selectedArray[count] = selectBox.options[i].value;
        count++;
      }
    }

    return selectedArray; 
  }

  function popupSubcategory()
  {
<%
      PredicateBean predicateBeanTemp = predicateBeanMap.get( CATEGORY_PREDICATE_NAME );
      String categoryListId = predicateBeanTemp == null ? "" : predicateBeanTemp.getPredicateValueWidgetId();  
%>
      var categoryListId = "<%= categoryListId%>";
      var categoryList = document.getElementById( categoryListId );
      if ( categoryList == null )
      {
         alert( "Script failure: cannot get category list." );
         return;
      }

      var selectedCategories = getSelectedOptions( categoryList );
      var selectedCategoriesIncludesAny = false;
      for ( var i = 0; i &lt; selectedCategories.length; i++ )
      {
        if ( selectedCategories[i] == "<%=subscriptionBean.getAnyPredicateListValue() %>" )
        {
          selectedCategoriesIncludesAny = true;
          break;
        }
      }

      if ( selectedCategories.length == 0 || selectedCategoriesIncludesAny )
      {
        alert( "The ANY option in the Category field cannot be selected when selecting subcategories; you must select specific categories before you can select subcategories." );
        return;
      }

      var selectedCategoriesUrlList = ""; 
      for ( var j = 0; j &lt; selectedCategories.length; j++ )
      {
        if ( j &gt; 0 )
        {
          selectedCategoriesUrlList += ","
        }

        selectedCategoriesUrlList += selectedCategories[j];  
      }
      selectedCategoriesUrlList = encodeURI( selectedCategoriesUrlList );

      href = "<%= SUBCATEGORY_POPUP_URL + "?" + CATEGORY_PREDICATE_NAME + "=" %>"  + selectedCategoriesUrlList;

      popup( href, "subcategoryWindow" ); 

      return false; 
  }

    function popupAffectedCI()
    {
        href = "<%= AFFECTED_CI_POPUP_URL %>";

        popup( href, "affectedCIWindow" );

        return false;
    }

</script>

<h3>HP Service Manager 9.34 Change Management</h3>
<br/>
<input type="hidden" name="currentTab" value="<%=request.getParameter("currentTab")%>" /> 

<text-widget id="name">
  <value><%= subscriptionBean.getName() %></value>
</text-widget>

<group label="Attributes">

<tab-group id="attributes">

<%
if(!creatingSubscription) {
%>

    <tab-content id="summary_tab" label="Summary">
        <div class="form-row">
          <label id="matching">Matching Any Event Where</label>
        </div>
        <div class="form-row">
        <ul id="summary_list">
<%
  iterator = subscriptionBean.getPredicateIterator();
  boolean firstNonEmptyPredicate = true;
  while(iterator.hasNext()) {
     final PredicateBean predicate = iterator.next();
     if(!predicate.getSelectedValues().isEmpty()) {
       String summary = predicateSummaryNamesMap.get(predicate.getPredicateName().toLowerCase());
       String predPosition = predicateTabPositionMap.get(predicate.getPredicateName().toLowerCase());
%>
       <% if(!firstNonEmptyPredicate) { %>
              <li class="summary_AND">
              <span class="summary_text">AND</span>
              </li>
             <%}%>

          <li class="summary-item">
            <span class="predicate_data"><%=predicateLabelMap.get(predicate.getPredicateName().toLowerCase())%></span>
      <span class="summary_text italic"> <%=predicate.getSelectedOperatorType()%></span>
            <span class="predicate_data"> (<%=StringEscapeUtils.escapeHtml(summary)%></span>
            <% if(summary.length() == MAX_DISPLAY_CHARACTERS) { %>
            <span class="elipse" onclick="forms_showTab('attributes', <%=predPosition%>, <%=Integer.toString(tabCount)%>, '')" >...</span>
            <% } %>
            <span class="summary_text">)</span>
          </li>
<%
     firstNonEmptyPredicate = false;
     }
  }
%>
        </ul>
        </div>

        <div class="form-row">
          <label class="summary">Available:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.isOnSunday()) {
            out.print("<span class=\"summary-item\">Sun</span>");
          }
          if(subscriptionBean.isOnMonday()) {
            out.print("<span class=\"summary-item\">Mon</span>");
          }
          if(subscriptionBean.isOnTuesday()) {
            out.print("<span class=\"summary-item\">Tue</span>");
          }
          if(subscriptionBean.isOnWednesday()) {
            out.print("<span class=\"summary-item\">Wed</span>");
          }
          if(subscriptionBean.isOnThursday())
          {
            out.print("<span class=\"summary-item\">Thu</span>");
          }
          if(subscriptionBean.isOnFriday())
          {
            out.print("<span class=\"summary-item\">Fri</span>");
          }
          if(subscriptionBean.isOnSaturday())
          {
            out.print("<span class=\"summary-item\">Sat</span>");
          }
%>

          <span class="summary-item"><%=subscriptionBean.getStartTime()%></span>
          <span class="summary-item">-</span>
          <span class="summary-item"><%=subscriptionBean.getEndTime()%></span>
        </span>
        </div>
        <div class="form-row">
          <label class="summary">Using:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.hasAllDeviceFilter())
          {
            out.print("<span class=\"summary-item\">All Devices</span>");
          }
          else
          {
            ArrayList<String> types = subscriptionBean.getDeviceTypeOverrides();
            for(String type : types)
            {
               String typeOverrideDisplay = type;
               if ( type.startsWith( NotificationAPI.DEVICE_FILTER_FIELD_PREFIX ) )
               {
                   typeOverrideDisplay = type.substring( NotificationAPI.DEVICE_FILTER_FIELD_PREFIX.length() );
               }
%>
            <span class="summary-item"><%=typeOverrideDisplay%></span>
<%
            }
          }
%>
          </span>
        </div>
<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
        <div class="form-row">
          <label class="summary">Targeting:</label>
         <span class="summary-row">
<%
         int charactersDisplayed = 0;
         ArrayList<String> recipients = subscriptionBean.getRecipients();
         for(String recipient : recipients)
         {
%>
            <span class="summary-item"><%=recipient%></span>
<%
           charactersDisplayed += recipient.length();
           if(charactersDisplayed > MAX_RECIPIENT_DISPLAY_CHARACTERS)
           {
             out.print("<span class=\"summary-item\">...</span>");
             break;
           }
         }
%>
          </span>
        </div>
<%
  }
}
%>

<%
if(!creatingSubscription) {
/*
* Display overrides if different from Subscription Domain defaults
*/
if (subscriptionBean.isOverrideDeviceTimeframes() != overrideTimeframeDefault) {
%>
        <div class="form-row">
          <label class="summary">Override User Device Timeframes:</label> Yes
        </div>
<%
}

if (subscriptionBean.isIgnoreDeviceDelays() != ignoreDeviceDelaysDefault) {
%>
        
        <div class="form-row">
          <label class="summary">Ignore Device Delays:</label> Yes
        </div>
<%
}

if (subscriptionBean.isOverrideDeviceSeverities() != overrideDeviceSeverityDefault) {
%>
        
        <div class="form-row">
          <label class="summary">Override Device Severities and Use All:</label> Yes
        </div>
<%
}

    if (subscriptionBean.getNotificationDelay() != 0) {
%>
        <div class="form-row">
          <label class="summary">Notification Delay:</label>
          <span class="summary-item"><%=subscriptionBean.getNotificationDelay()%> min</span>
        </div>
<%
    }
    %>
    </tab-content>
<%
}
%>
    <tab-content id="ch_info_tab" label="Change Information">
<%
    for(String predicateName : predicateList)
    {
      PredicateBean predicate = predicateBeanMap.get(predicateName);
      ArrayList<String> selectedValues = selectedPredicateValuesMap.get(predicateName);
      
      if (predicate != null)
      {
          if ( predicateName.equals( ASSIGNED_TO_DEPT_PREDICATE_NAME )
            || predicateName.equals( CHANGE_COORDINATOR_PREDICATE_NAME )
            || predicateName.equals( INITIATOR_PREDICATE_NAME ) )
          {
              PredicateBean predicateBean = predicateBeanMap.get( predicateName );
%>
      <multifield-grouping>
        <pulldown-select id="<%=predicateBean.getOperatorWidgetId()%>"
                         label="<%=predicateLabelMap.get(predicateName)%>:" force-label="true"
<%
              if( predicateBean.getSelectedOperatorType() != null )
              {
                  out.print( "value=\""+ predicateBean.getSelectedOperatorType() +"\"" );
              }
              out.print( ">" ); // close pulldown-select tag

              for ( String operatorType : subscriptionBean.getValidOperatorTypeValues() )
              {
%>
          <selection-item value="<%=operatorType%>" label="<%=operatorType%>" />
<%
              }
%>
        </pulldown-select>
        <span id="<%=predicateBean.getPredicateValueWidgetId()%>">
          <input type="text" size="20"
                 id="<%=predicateBean.getPredicateValueWidgetId()%>"
                 name="<%=predicateBean.getPredicateValueWidgetId()%>"
                 value="<%= StringEscapeUtils.escapeHtml( predicateBean.getSelectedValue() )%>" />
        </span>
        <span class="italic">Empty Field = Any Value</span>
      </multifield-grouping>
<%
          }
          else // other predicates
          {
%>
      <div class="form-row">
        <label class="widget" for="<%=predicate.getPredicateValueWidgetId()%>"><%=predicateLabelMap.get(predicateName)%>:</label>
        <span  id="<%=predicate.getPredicateValueWidgetId()+"_span"%>">
          <select class="floatLeft" size="5" multiple="0" id="<%=predicate.getPredicateValueWidgetId()%>" name="<%=predicate.getPredicateValueWidgetId()%>" >
<%
            if( !predicateName.equals( SUBCATEGORY_PREDICATE_NAME ) && !predicateName.equals( AFFECTED_CI_PREDICATE_NAME ) )
            {
%>
            <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedValues.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
<%
            }
              Collection<String> listBoxValues = null;
              if ( QUERY_PREDICATE_VALUES )
              {
                  if( predicateName.equals( CATEGORY_PREDICATE_NAME ) )
                  {
                      listBoxValues = serviceManagerCmBean.getSortedList("RetrieveCMCategoryListRequest", "name<>NULL", "name");
                  }
                  else if( predicateName.equals( SERVICE_PREDICATE_NAME ) )
                  {
                      listBoxValues = serviceManagerCmBean.getSortedList("RetrieveBizserviceListRequest", "logical.name<>NULL", "Name");
                  }
                  else if( predicateName.equals( SUBCATEGORY_PREDICATE_NAME ) || predicateName.equals( AFFECTED_CI_PREDICATE_NAME ) )
                  {
                      listBoxValues = selectedValues;
                  }
                  else if( predicateName.equals( TRIGGER_RULE_PREDICATE_NAME ) )
                  {
                      listBoxValues = new ArrayList<String>();
                      listBoxValues.add( TRIGGER_RULE_APPROVAL );
                      listBoxValues.add( TRIGGER_RULE_PHASE_CHANGE );
                  }
              }
              if ( listBoxValues == null )
              {
                  listBoxValues = predicate.getPredicateValues();
              }

              for ( String predicateValue : listBoxValues )
              {
                  String escapedPredicateValue = StringEscapeUtils.escapeHtml( predicateValue );

                  // very special handling when dealing with trigger_rule value "Phase Change" for it to selected on new subscriptions
                  Boolean selected =  selectedValues.contains( predicateValue ) || ( predicateName.equals( TRIGGER_RULE_PREDICATE_NAME ) && predicateValue.equals( TRIGGER_RULE_PHASE_CHANGE ) && creatingSubscription );
%>
                  <option value="<%= escapedPredicateValue%>" <% if( selected )  out.print("selected=\"true\""); %> ><%= escapedPredicateValue%></option>
<%
              }
%>
           </select>
<%
              if( QUERY_PREDICATE_VALUES && predicateName.equals( SUBCATEGORY_PREDICATE_NAME ) )
              {
%>
           <action-button id="subcategoryButton" class="floatLeft" label="Select Subcategory" onclick="popupSubcategory();return false;" />
<%                                
              }
%>
<%
              if( QUERY_PREDICATE_VALUES && predicateName.equals( AFFECTED_CI_PREDICATE_NAME ) )
              {
%>
           <action-button id="affectedCiButton" class="floatLeft" label="Select Affected CIs" onclick="popupAffectedCI();return false;" />
<%
              }
%>

        </span>
      </div>
<%        }  // other predicates else finished
      } // if predicate != null
      else
      {
          out.println("<div class=\"system-msg-error\">Unexpected exception occurred: The value " + predicateName + " has not been defined as a predicate for the Event Domain on which this Subscription is based, or has not been added to the Subscription Domain.</div>"); 
      }
    } // for each predicate
%>

    </tab-content>

    <tab-content id="preferences_tab" label="Preferences">
        <% if(!subscriptionBean.isTimeframeSuppressed()){ %>
            <subscription-timeframe group-label="Timeframe" />
        <% } %>
        <subscription-overrides group-label="Overrides" />
        
    </tab-content>

<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
    <tab-content id="assigned_tab" label="Assign">

      <subscribed-recipients group-label="Recipients" />

    </tab-content>
<%
  }
%>
</tab-group>

</group>

</subscription-panel>
